package ca.aura.algorithms.normalizer;

import ca.aabeka.math.Sequence;
import ca.aura.algorithms.rank.Rank;

/**
 * 
 * @author Andrew
 *
 */
public class DecreasingRankNormalizer extends RankNormalizer {

  //`````````````````
  // constructor
  //`````````````````

  /**
   * 
   * you cannot create a rank directly
   * 
   */
  
  public DecreasingRankNormalizer(Sequence sequence) {
    super(sequence);
  }

  /**
   * @see ca.aura.rank.RankNormalizer#getRankDivisions()
   */
  public double[] getRankDivisions() {
    double[] rankDivisions = new double[3];
    rankDivisions[0] = -1.5;
    rankDivisions[1] = 0;
    rankDivisions[2] = 1.5;
    return rankDivisions;
  }

  /**
   * @see ca.aura.rank.RankNormalizer#getRanks()
   */
  public Rank[] getRanks() {
    Rank[] ranks = new Rank[4];
    ranks[0] = new Rank(4);
    ranks[1] = new Rank(3);
    ranks[2] = new Rank(2);
    ranks[3] = new Rank(1);  
    return ranks;
  }

}
