package ca.aura.algorithms.rank;

import ca.aura.resources.RankResource;

/**
 * @author aforward
 *
 */
public class Rank {

  
  private int value_;

  //`````````````````
  // constructor
  //`````````````````

  /**
   * 
   * default
   * 
   */
  
  public Rank() {
    init(getUnknown());	
  }

  /**
   * 
   * give it a value
   * 
   */
  
  public Rank(int value) {
    init(value);	
  }

  private void init(int value) {
    value_ = value;
  }

  //`````````````````
  // interface
  //`````````````````

  /**
   * 
   * is the rank unknown?
   * 
   */ 
  
  public boolean isUnknown() {
    return normalize(value_) == getUnknown();	
  }

  /**
   * 
   * get the rank 
   * 
   */ 

  public int getRank() {
    return normalize(value_);   
  }


  //`````````````````
  // object interface
  //`````````````````

  /**
   * 
   * are they equals?
   * 
   */ 

  public boolean equals(Object obj) {
   if (!(obj instanceof Rank)) {
     return false;	
   } 	
   
   Rank rank = (Rank)obj;
   return getRank() == rank.getRank();
  }

  /**
   * 
   * show the object as a string
   * 
   */ 

  public String toString() {
    return getRank() + "";	
  }

  //`````````````````
  // static
  //`````````````````

  /**
   * 
   * get the minimum rank value
   * 
   */ 

  public static int getMinimum() {
    return RankResource.getDefault().getMinimumRank();  
  }

  /**
   * 
   * get the maximum rank value
   * 
   */ 

  public static int getMaximum() {
    return RankResource.getDefault().getMaximumRank();  
  }

  /**
   * 
   * get the unknown rank value
   * 
   */ 

  public static int getUnknown() {
    return getMinimum() - 1;
  }

  //`````````````````
  // protected
  //`````````````````

  /**
   * 
   * normalize the value
   * 
   */

  protected int normalize(int value) {
    if (value != getUnknown() && (value < getMinimum() || value > getMaximum())) {
      return getUnknown();  	
    }	
    return value;
  }

}
