package ca.aura.artefacts;

import java.io.File;

/**
 * 
 * @author Andrew
 *
 */
public class Location {

  private String fileName_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */
  
  public Location() {
    init("");  
  }

  /**
   * 
   * give a location a file name
   * 
   */
  public Location(String fileName) {
    init(fileName);  
  }  

  private void init(String fileName) {
    fileName_ = fileName;
  }

  //``````````````````````
  // interface
  //``````````````````````
  
  /**
   * 
   * is the location valid?
   * 
   */
  public boolean doesExist() {
    return new File(fileName_).exists();
  }

  /**
   * 
   * set the file name of the location
   * 
   */
  public void setFilename(String filename) {
    fileName_ = filename;
  }

  /**
   * 
   * get the filename of the location
   * 
   */
  public String getFilename() {
    return fileName_;
  }

  

  //``````````````````````
  // object interface
  //``````````````````````
  
  /**
   * 
   * check for equality
   * 
   */
  
  public boolean equals(Object obj) {
    if (!(obj instanceof Location)) {
      return false;	
    }
    
    Location location = (Location)obj;
    
    if (!toString().equals(location.toString())) {
      return false;  
    }
    	
    return true;	
  }
  
  /**
   * 
   * the object as a string
   * 
   */
  
  public String toString() {
    return fileName_;  	
  }


}
