package ca.aura.artefacts.reports;

import java.util.Iterator;

import ca.aabeka.util.Vector;
import ca.aura.artefacts.usage.UsageManager;
import ca.aura.project.History;

/**
 * 
 * @author aforward
 *
 */
public class LRFUReport extends ManagedReport {

  private static UsageManager manager_;

  //`````````````````````
  // constructor
  //`````````````````````

  /**
   * 
   * default
   * 
   */

  public LRFUReport(History history) {
    super(history);   
  }


  /**
   * 
   * specify the search results to consider
   * 
   */
  
  public LRFUReport(History history, Vector results) {
    super(history,results); 
  }

  /**
   * 
   * specify the search results to consider
   * 
   */
  
  public LRFUReport(History history, Iterator results) {
    super(history,new Vector(results)); 
  }


  /**
   * @see ca.aura.artefacts.reports.ManagedReport#getUsageManager()
   */
  protected synchronized UsageManager getUsageManager() {
    if (manager_ == null) {
      manager_ = new UsageManager();
      manager_.setConsulting();      
    }
    return manager_;
  }

}
