package ca.aura.artefacts.reports;

import java.util.Iterator;

import ca.aabeka.util.Debug;
import ca.aabeka.util.Vector;
import ca.aura.artefacts.Artefact;
import ca.aura.artefacts.usage.Usage;
import ca.aura.artefacts.usage.UsageManager;
import ca.aura.project.History;

/**
 * 
 * @author aforward
 *
 */
public abstract class ManagedReport extends DefaultReport {

  Vector searchResults_;

  //`````````````````````
  // constructor
  //`````````````````````

  /**
   * 
   * default
   * 
   */

  public ManagedReport(History history) {
    Vector artefacts = new Vector();
    artefacts.addAll(history.getArtefacts());
       
    init(history, artefacts);    
    
    
    Iterator iter = artefacts.iterator();
    while (iter.hasNext()) {
      Debug.defaultPrintln(this,"class: " + iter.next().getClass());  
    }
    
    
    
  }


  /**
   * 
   * specify the search results to consider
   * 
   */
  
  public ManagedReport(History history, Vector results) {
    init(history,results);   
  }


  private void init(History history, Vector results) {
    searchResults_ = results;

    UsageManager manager = getUsageManager();

    Iterator iter = history.getHistory();
    while(iter.hasNext()) {
      Usage usage = (Usage)iter.next();
      String artefactId = usage.getArtefactId();

      if (manager.isApplicable(usage) && isVisible(artefactId)) {
        Artefact artefact = (Artefact)results.get(artefactId);
        add(artefact, usage);
      }
    }
  }

  //`````````````````````
  // abstract interface
  //`````````````````````

  /**
   * 
   * What type of usage manager shoudl we use?
   * 
   */
  
  protected abstract UsageManager getUsageManager();


  //`````````````````````
  // protected
  //`````````````````````

  /**
   * 
   * default
   * 
   */

  protected boolean isVisible(String artefactId) {
    boolean isVisible = searchResults_.contains(artefactId);
    Debug.defaultPrintln(this,"isVisible " + artefactId + " in " + searchResults_ + " : " + isVisible);
    return isVisible;    
  }





   

}
