package ca.aura.artefacts.sorting;

import java.text.Collator;
import java.util.Iterator;
import java.util.Locale;

import ca.aabeka.util.Debug;
import ca.aabeka.util.Node;
import ca.aabeka.util.StructuredNode;
import ca.aabeka.util.Vector;
import ca.aura.artefacts.Artefact;


/**
 * 
 * @author aforward
 *
 */
public class ResultSet extends StructuredNode {

  //``````````````````
  // constructor
  //``````````````````

  /**
   * 
   * default
   * 
   */

  public ResultSet() {
    super();
    init();
  }

  /**
   * 
   * give the domain a name
   * 
   */

  public ResultSet(String name) {
    super(name);
    init();
  }

  /**
   * 
   * give the results some values
   * 
   */
  
  public ResultSet(Iterator artefacts) {
    init();
    
    while (artefacts.hasNext()) {
      Debug.defaultPrintln(this,"adding");
      Artefact next = (Artefact)artefacts.next();
      boolean wasAdded = add(new Data(next));  
      Debug.defaultPrintln(this,":" + wasAdded);
    }
  }


  private void init() {
    addChildType(Data.class);
  }

  //`````````````````````
  // interface
  //`````````````````````

  /**
   * 
   * sort by artefact name
   * 
   */

  public void sortByName() {
    
    Collator collator = Collator.getInstance(Locale.getDefault());
    
    Vector v = new Vector();

    Vector children = getAllChildren();
    for (int i=0; i < children.size() ; i++) {
      Data d = (Data)children.elementAt(i);
      String name = d.getData().getName();
      
      if (i==0) {
        v.add(d);  
      }
      
      for (int j=0; j < v.size(); j++) {
        String index = ((Data)v.elementAt(j)).getData().getName();
        if (collator.compare(name, index) < 0 ) {
          v.insertElementAt(d, j);
          break;  
        }
        
        if (j+1 == v.size()) {
          v.add(d);
          break;  
        }
      }
    }

    removeAll();

    Iterator iter = v.iterator();
    while (iter.hasNext()) {
      add((Node)iter.next());
    }    


    
    
  }
  



}
