package ca.aura.resources;

import java.util.Vector;

import ca.aabeka.util.Resource;

public class TaskResource extends Resource {

  private static TaskResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private TaskResource() { 
    init();
  }

  private void init() {
    add("ca.aura.resources.task");
  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized TaskResource getDefault() {
    if (this_ == null) {
      this_ = new TaskResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````

  /**
   * 
   * get the default task
   * 
   */

  public String getDefaultTask() {
    String key = "task.list";
    String defaultt = "browse";
    Vector tasks = getList(key);
    
    if (tasks.size() == 0) {
      return defaultt;  
    }
    
    return (String)tasks.elementAt(0);
  }

  /**
   * 
   * normalize the task
   * 
   */

  public String normalize(String task) {
    String key = "task.list";
    Vector tasks = getList(key);
    
    if (tasks.size() == 0) {
      return getDefaultTask();  
    }
    
    if (!tasks.contains(task)) {
      return (String)tasks.elementAt(0);
    }
    
    return task;
  }


}
