package ca.aura.ui.resources;

import org.eclipse.swt.graphics.Color;

import ca.aabeka.ui.ImageController;
import ca.aabeka.util.Resource;

public class InputResource extends Resource {

  private static InputResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private InputResource() { 
    init();
  }

  private void init() {
    add("ca.aura.resources.ui_input");
  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized InputResource getDefault() {
    if (this_ == null) {
      this_ = new InputResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````

  /**
   * 
   * get the background colour
   * 
   */

  public Color getBackgroundColour() {
    String key = "background.color";
    String defaultt = "0 0 0";
    String color = getString(key,defaultt); 
    return ImageController.getColour(color);
  }


  /**
   * 
   * get the open file text
   * 
   */
  
  public String getAddDocumentText() {
    String key = "add.document";
    String defaultt = "Add Document";
    return getString(key,defaultt);
  }

}
