package ca.aura.ui.resources;

import ca.aabeka.util.Resource;

public class RelevancerSettingsResource extends Resource {

  private static RelevancerSettingsResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private RelevancerSettingsResource() { 
    init();
  }

  private void init() {
    add("ca.aura.resources.ui_relevance");
  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized RelevancerSettingsResource getDefault() {
    if (this_ == null) {
      this_ = new RelevancerSettingsResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````

  /**
   * 
   * get the Group name
   * 
   */
  
  public String getGroupText() {
    String key = "group.text";
    String defaultt = "Relevance Settings";
    return getString(key,defaultt);  
  }

  /**
   * 
   * get the intro text
   * 
   */
  
  public String getIntroText() {
    String key = "group.intro";
    String defaultt = "Select the appropriate weighting factor for each of the following factors:";
    return getString(key,defaultt);
      
  }
  
  /**
   * 
   * get the age text
   * 
   */
  
  public String getAgeText() {
    String key = "relevance.age";
    String defaultt = "Age";
    return getString(key,defaultt);    
  }

  /**
   * 
   * get the age tooltip
   * 
   */
  
  public String getAgeToolTip() {
    String key = "relevance.age.toolTip";
    String defaultt = "Set how important the age of a document reflects its relevance.";
    return getString(key,defaultt);    
  }


  /**
   * 
   * get the integrity text
   * 
   */  
  
  public String getIntegrityText() {
    String key = "relevance.integrity";
    String defaultt = "Integrity";
    return getString(key,defaultt);    
  }

  /**
   * 
   * get the integrity tooltip
   * 
   */  
  
  public String getIntegrityToolTip() {
    String key = "relevance.integrity.toolTip";
    String defaultt = "Set how important the integrity of the references in your document reflects an artefacts relevance.";
    return getString(key,defaultt);    
  }

  /**
   * 
   * get the authority text
   * 
   */
  
  public String getAuthorityText() {
    String key = "relevance.authority";
    String defaultt = "Authority";
    return getString(key,defaultt);    
  }

  /**
   * 
   * get the authority tooltip
   * 
   */
  
  public String getAuthorityToolTip() {
    String key = "relevance.authority.tooTip";
    String defaultt = "Set how important the # of in / out references reflect an artefacts relevance (like Google ranking).";
    return getString(key,defaultt);    
  }
  
  
  /**
   * 
   * get the usage text
   * 
   */
  public String getUsageText() {
    String key = "relevance.usage";
    String defaultt = "Usage";
    return getString(key,defaultt);  
  }

  /**
   * 
   * get the usage tooltip
   * 
   */
  public String getUsageToolTip() {
    String key = "relevance.usage.toolTip";
    String defaultt = "Set how important the usage (frequency and recency) reflect an artefacts relevance.";
    return getString(key,defaultt);  
  }

  /**
   * 
   * get the feedback text
   * 
   */
  public String getFeedbackText() {
    String key = "relevance.feedback";
    String defaultt = "Feedback";
    return getString(key,defaultt);  
  }

  /**
   * 
   * get the feedback text
   * 
   */
  public String getFeedbackToolTip() {
    String key = "relevance.feedback.toolTip";
    String defaultt = "Set how important feedback from others reflect an artefacts relevance.";
    return getString(key,defaultt);  
  }

}
