package ca.aura.ui.resources;

import org.eclipse.swt.graphics.Image;

import ca.aabeka.ui.ImageController;
import ca.aabeka.util.Resource;

public class ShellResource extends Resource {

  private static ShellResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private ShellResource() { 
    init();
  }

  private void init() {
    add("ca.aura.resources.ui");
  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized ShellResource getDefault() {
    if (this_ == null) {
      this_ = new ShellResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````

  /**
   * 
   * get the logo image
   * 
   */


  public Image getLogoImage() {
    String key = "logo.image";
    Image image = ImageController.getImage(getBase(),this,key);
    return image;
  }

  
  /**
   * 
   * get the shell name
   * 
   */
  
  public String getName() {
    String key = "shell.name";
    String defaultt = "Document Aura Visualization";
    return getString(key,defaultt);
  }

}

