package ca.aura.ui.swt;

import ca.aabeka.util.Graph;
import ca.aura.artefacts.sorting.ResultSet;
import ca.aura.project.Structure;
import ca.aura.ui.resources.ShellResource;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;

/**
 * 
 * @author Andrew
 *
 */
public class ShellView {

  Shell shell_;

  WhiteBoardView wbView_;
  ResultSetView rsView_;
  StructureView dView_;

  //``````````````````````
  // constructor
  //``````````````````````

  /**
   * 
   * default
   * 
   */
  
  protected ShellView(Shell shell) {
    init(shell);  
  }

  private void init(Shell shell) {

    shell.setImage(ShellResource.getDefault().getLogoImage());
    shell.setText(ShellResource.getDefault().getName());
    
    shell.setLayout(new FillLayout());


    SashForm top = new SashForm(shell, SWT.VERTICAL);

    wbView_ = WhiteBoardView.build(top);    
    Composite filler = new Composite(top,SWT.BORDER);
    filler.setLayout(new FillLayout());
    
    SashForm bottom = new SashForm(filler, SWT.HORIZONTAL);

    //InputUI.build(bottom);
    dView_ = StructureView.build(bottom);
    rsView_ = ResultSetView.build(bottom);
    //ParametersUI.build(bottom);
    //MaintenanceTask.build(bottom);
    
    
    shell.pack();
    shell.open ();

  }

  //`````````````````````
  // interface
  //`````````````````````

  /**
   * 
   * set the depot
   * 
   */
  
  public void setDepot(Structure depot) {
    dView_.setStructure(depot);  
  }

  /**
   * 
   * set the result set
   * 
   */

  public void setResultSet(ResultSet rs) {
    rsView_.setResultSet(rs);  
  }

  /**
   * 
   * set the graph
   * 
   */

  public void setGraph(Object obj, Graph graph) {
    wbView_.setGraph(obj, graph);  
  }

  /**
   * 
   * build the shell
   * 
   */
  
  public static ShellView build(Shell shell) {
    return new ShellView(shell);
  }

}
