package ca.aura.ui.swt;

import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
//import org.eclipse.swt.widgets.Menu;
//import org.eclipse.swt.widgets.MenuItem;

import ca.aura.project.Structure;
import ca.aura.ui.swt.actions.FileDropTarget;


/**
 * 
 * @author aforward
 *
 */
public class StructureView {

  private Composite self_;
  
  private TreeViewer viewer_;


  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */
  
  protected StructureView(Composite self) {
    init(self);  
  }
  
  private void init(Composite self) {

    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;
    gridLayout.verticalSpacing = 2;
    gridLayout.marginWidth = 0;
    gridLayout.marginHeight = 2;
    
    self.setLayout(gridLayout);

    viewer_ = new TreeViewer(self);
    viewer_.setContentProvider(new StructureContentProvider());
    viewer_.setLabelProvider(new StructureLabelProvider());
    viewer_.setUseHashlookup(true);

    GridData layoutData = new GridData();
    layoutData.grabExcessHorizontalSpace = true;
    layoutData.grabExcessVerticalSpace = true;
    layoutData.horizontalAlignment = GridData.FILL;
    layoutData.verticalAlignment = GridData.FILL;        

    viewer_.getControl().setLayoutData(layoutData);
    
    FileDropTarget.buildDragAndDrop(viewer_.getControl());
    
    /*
    
    Menu menu = new Menu(viewer_.getTree().getShell(),SWT.POP_UP);
    MenuItem item = new MenuItem(menu,SWT.NULL);
    item.setText("1");
    
    item = new MenuItem(menu,SWT.NULL);
    item.setText("2"); 
    
    viewer_.getTree().setMenu(menu);
    
    */
    
    
    
    
  }

  /**
   * 
   * build a whiteboard ui
   * 
   */  
 
  public static  synchronized StructureView build(Composite composite) {
    Composite self = new Composite(composite, SWT.NO_MERGE_PAINTS);
    return buildSelf(self);
  }

  /**
   * 
   * build self
   * 
   */  

  public static synchronized StructureView buildSelf(Composite self) {
    return new StructureView(self);  
  }


  //`````````````````````
  // interface
  //`````````````````````

  /**
   * 
   * set the project depot
   * 
   */

  public void setStructure(Structure structure) {
    viewer_.setInput(structure);  
  }




}
