package ca.aura.ui.swt.actions;

import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.DropTargetAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.dnd.TransferData;
import org.eclipse.swt.widgets.Control;

import ca.aabeka.util.Debug;

/**
 * 
 * @author Andrew
 *
 */
public class FileDropTarget {

  private static final int OPERATIONS = DND.DROP_MOVE | DND.DROP_COPY | DND.DROP_LINK;

  private Control control_;
  private DropTarget dropTarget_;
  private Transfer[] types_;

  //``````````````````````
  // constructor
  //``````````````````````

  /**
   * 
   * default
   * 
   */
  
  protected FileDropTarget(Control control) {
    init(control);  
  }

  private void init(Control control) {
    control_ = control;  
    types_ = new Transfer[] {FileTransfer.getInstance()};

    dropTarget_ = new DropTarget(control,OPERATIONS);
    dropTarget_.setTransfer(types_);
    dropTarget_.addDropListener(new FileDropListener()); 

    
    Debug.defaultPrintln(this,dropTarget_);
  }

  //``````````````````````
  // interface
  //``````````````````````

  public static FileDropTarget buildDragAndDrop(Control control) {
    return new FileDropTarget(control);  
  }


  //``````````````````````
  // inner classes
  //``````````````````````
  
  /**
   * 
   * the drop target listener
   * 
   */

  public class FileDropListener extends DropTargetAdapter {

    /**
     * 
     * @see org.eclipse.swt.dnd.DropTargetAdapter#dragEnter(DropTargetEvent)
     * 
     */
    public void dragEnter(DropTargetEvent event) {

      TransferData data = event.currentDataType;
      //FileTransfer transfer = (FileTransfer)event.currentDataType;

      FileTransfer transfer = FileTransfer.getInstance();
      String[] files = (String[])transfer.nativeToJava(data);      

      Debug.defaultPrintln(this,"enter:" + event);
      Debug.defaultPrintln(this,"enter:" + event.data);
      Debug.defaultPrintln(this,"enter:" + files[0]);
      
      

      
      
    }


    /**
     * 
     * @see org.eclipse.swt.dnd.DropTargetAdapter#drop(DropTargetEvent)
     * 
     */
    public void drop(DropTargetEvent event) {
      

      
      DropTarget target = (DropTarget)event.getSource();

      Debug.defaultPrintln(this,target);

      //PathContent pc = new


    }
  }

}
