package ca.aura.ui.swt.actions;

import ca.aabeka.util.Debug;
import ca.aura.resources.FileResource;

import java.io.File;

public class LaunchFileAction implements Action {



  private File file_;

  //`````````````````
  // constructor
  //`````````````````

  /**
   * 
   * default constructor
   * 
   */
  
  public LaunchFileAction(File f) {
    init(f);  
  }

  private void init(File f) {
    file_ = f;  
  }

  //`````````````````
  // constructor
  //`````````````````

  /**
   * 
   * do the action
   * 
   */

  public boolean execute() {

    if (file_ == null) {
      return false;  
    }

    String run = FileResource.getDefault().getLaunchCommand(file_);  

    Debug.defaultPrintln(this,"launching:" + run);

    try {
      Runtime.getRuntime().exec(run);
      return true;
    } catch (Exception err) {
      return false; 
    }
  }

}
