package ca.aura.xml;

import org.jdom.Element;

import ca.aabeka.xml.ObjectXmlConverter;
import ca.aura.artefacts.Location;

/**
 * 
 * @author aforward
 *
 */
public class LocationXmlConverter implements ObjectXmlConverter {

  private static final String ELEMENT_LOCATION = "location"; 

  /**
   * @see ca.aabeka.xml.ObjectXmlConverter#getElementName()
   */
  public String getElementName() {
    return ELEMENT_LOCATION;
  }

  /**
   * @see ca.aabeka.xml.ObjectXmlConverter#canLoad(Element)
   */
  public boolean canLoad(Element ele) {
    if (ele == null) {
      return false;
    }

    return getElementName().equals(ele.getName());
  }

  /**
   * @see ca.aabeka.xml.ObjectXmlConverter#canBuild(Object)
   */
  public boolean canBuild(Object obj) {
    return (obj instanceof Location);
  }

  /**
   * @see ca.aabeka.xml.ObjectXmlConverter#load(Element)
   */
  public Object load(Element ele) {
    
    
    
    Location location = new Location();
    
    if (!canLoad(ele)) {
      return location;  
    }
    
    location.setFilename(ele.getTextTrim());
    return location;
  }

  /**
   * @see ca.aabeka.xml.ObjectXmlConverter#build(Object)
   */
  public Element build(Object obj) {

    Element ele = new Element(getElementName());
    
    if (!canBuild(obj)) {
      return ele;  
    }

    Location location = (Location)obj;
    ele.setText(location.getFilename());

    return ele;
  }

}
