package ca.aura.xml;

import junit.framework.Test;
import junit.framework.TestSuite;

import ca.aabeka.xml.AbstractXmlConverterTest;
import ca.aabeka.xml.ObjectXmlConverter;
import ca.aura.artefact.components.Description;

/**
 * 
 * @author Andrew
 *
 */
public class DescriptionXmlConverterTest extends AbstractXmlConverterTest {

  //```````````````````
  // all tests
  //```````````````````
  
  /**
   * 
   * the main runner
   * 
   */
  
  public static void main () {
    junit.textui.TestRunner.run (suite());
  }
  
  /**
   * 
   * the test suite to group tests together
   * 
   */
  
  public static Test suite() {
    return new TestSuite(DescriptionXmlConverterTest.class);
  }

  private static final String DESCRIPTION = (new DescriptionXmlConverter()).getElementName();

  //``````````````````````
  // abstract interface
  //``````````````````````

  /**
   * 
   * @see ca.aura.xml.AbstractXmlConverterTest#getConverter()
   * 
   */
  public ObjectXmlConverter getConverter() {
    return new DescriptionXmlConverter();
  }

  /**
   * @see ca.aura.xml.AbstractXmlConverterTest#test_load()
   */
  public void test_load() {
    String xml = "<"+ DESCRIPTION +">1</"+ DESCRIPTION +">";
    Description expected = new Description("1");
    assert_load(xml,expected);
  }

  /**
   * @see ca.aura.xml.AbstractXmlConverterTest#test_build()
   */
  public void test_build() {
    
    
    Description object = new Description("2");
    String expected = "<"+ DESCRIPTION +">2</"+ DESCRIPTION +">";
    assert_build(object,expected);
  }

}
