package ca.aura.xml;

import org.jdom.Element;

import ca.aabeka.xml.ObjectXmlConverter;
import ca.aura.artefact.components.Location;

/**
 * 
 * @author Andrew
 *
 */
public class LocationXmlConverter implements ObjectXmlConverter {

  private static final String ELEMENT_LOCATION = "location";


  public static final String ELEMENT_ROOT = ELEMENT_LOCATION;

  /**
   * 
   * @see ca.aabeka.xml.ObjectXmlConverter#getElementName()
   * 
   * get the Element name
   * 
   */

  public String getElementName() {
    return ELEMENT_ROOT;  
  }

  /**
   * @see ca.aabeka.xml.ObjectXmlConverter#load(Element)
   */
  public Object load(Element ele) {
    
    if (ele == null) {
      return new Location();	
    }
    
    if (ELEMENT_LOCATION.equals(ele.getName())) {
      return new Location();  
    }
    
    
    return new Location(ele.getTextTrim());
  }

  /**
   * @see ca.aabeka.xml.ObjectXmlConverter#build(Object)
   */
  public Element build(Object obj) {
    if (!(obj instanceof Location)) {
      return new Element(ELEMENT_LOCATION);	
    }

    return buildLocation((Location)obj);
  }


  //``````````````````````
  // protected
  //``````````````````````
  
  /**
   * 
   * build the element from a location
   * 
   */
  
  protected Element buildLocation(Location location) {
    Element ele = new Element(ELEMENT_LOCATION);
    ele.setText(location.toString());  
    return ele;
  }

}
