package ca.aura.xml;

import junit.framework.Test;
import junit.framework.TestSuite;

import ca.aabeka.xml.AbstractXmlConverterTest;
import ca.aabeka.xml.ObjectXmlConverter;
import ca.aura.artefact.Reference;

/**
 * 
 * @author Andrew
 *
 */
public class ReferenceXmlConverterTest extends AbstractXmlConverterTest {

  //```````````````````
  // all tests
  //```````````````````
  
  /**
   * 
   * the main runner
   * 
   */
  
  public static void main () {
    junit.textui.TestRunner.run (suite());
  }
  
  /**
   * 
   * the test suite to group tests together
   * 
   */
  
  public static Test suite() {
    return new TestSuite(ReferenceXmlConverterTest.class);
  }

  /**
   * 
   * @see ca.aura.xml.AbstractXmlConverterTest#getConverter()
   * 
   */
  public ObjectXmlConverter getConverter() {
    return new ReferenceXmlConverter();
  }

  /**
   * @see ca.aura.xml.AbstractXmlConverterTest#test_load()
   */
  public void test_load() {
    String xml = "<artefact name='1' id='2' />";
    Reference expected = new Reference("2","1");
    assert_load(xml,expected);  
  }

  /**
   * @see ca.aura.xml.AbstractXmlConverterTest#test_build()
   */
  public void test_build() {
    Reference object = new Reference("2","1");
    String expected = "<artefact name='1' id='2' />";
    assert_build(object,expected);  
  
  }

}
