
package ca.aura.plugin;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;


/**
 * 
 * The Document Aura Perspective
 * 
 */
public class AuraPerspective implements IPerspectiveFactory {

  private static final String WHITEBOARD_VIEW_ID = "ca.aura.plugin.WhiteBoardViewer";
  private static final String REPORTSET_VIEW_ID = "ca.aura.plugin.ResultSetViewer";
  private static final String DEPOT_VIEW_ID = "ca.aura.plugin.DepotViewer";

  /**
   * 
   * @see IPerspectiveFactory#createInitialLayout(IPageLayout)
   * 
   */
  public void createInitialLayout(IPageLayout layout) {
      defineLayout(layout);
  }

  /**
   * 
   * define the layout
   * 
   */ 
  public void defineLayout(IPageLayout layout) {

        String editorArea = layout.getEditorArea();
        layout.setEditorAreaVisible(false);
        IFolderLayout top = layout.createFolder("top", IPageLayout.TOP, (float)0.5, editorArea);
        IFolderLayout bottom_left = layout.createFolder("bottom_left", IPageLayout.LEFT, (float)0.5, editorArea);
        IFolderLayout bottom_right = layout.createFolder("bottom_right", IPageLayout.RIGHT, (float)0.5, editorArea);

        bottom_left.addView(DEPOT_VIEW_ID); 
        bottom_right.addView(REPORTSET_VIEW_ID);
        top.addView(WHITEBOARD_VIEW_ID);

    
  }
}
