package ca.aura.algorithms.normalizer;

import ca.aabeka.math.Sequence;
import ca.aura.algorithms.rank.Rank;

import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * 
 * @author Andrew
 *
 */
public class DecreasingRankNormalizerTest extends AbstractRankNormalizerTest {


  //```````````````````
  // all tests
  //```````````````````
  
  /**
   * 
   * the main runner
   * 
   */
  
  public static void main () {
    junit.textui.TestRunner.run (suite());
  }
  
  /**
   * 
   * the test suite to group tests together
   * 
   */
  
  public static Test suite() {
    return new TestSuite(DecreasingRankNormalizerTest.class);
  }

  /**
   * 
   * getRank (increasing curve)
   * 
   * mean = 4
   * st dev = 2
   * 
   * rank 4, value < 1
   * rank 3, value < 4
   * rank 2, value < 7
   * rank 1, value >= 7
   * 
   */

  public RankNormalizer getRankNormalizer(Sequence sequence) {
    return new DecreasingRankNormalizer(sequence);    
  }
  
  public double getCoef(int rank) {
    if (rank == Rank.getUnknown()) {
      return 3;  
    } else if (rank == 4) {
      return 0.9;
    } else if (rank == 3) {
      return 3.9;
    } else if (rank == 2) {
      return 6.9;
    } else if (rank == 1) {
      return 7;
    } else {
      fail("unknown rank provided");
      return -1; 
    }
      
  }

}
