package ca.aura.resources;

import org.eclipse.swt.graphics.Image;
import ca.aabeka.ui.ImageController;
import ca.aabeka.util.Resource;

public class TestResource extends Resource {

  private static TestResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private TestResource() { 
    init();
  }

  private void init() {
    add("test");
  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized TestResource getDefault() {
    if (this_ == null) {
      this_ = new TestResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````

  /**
   * 
   * get the logo image
   * 
   */


  public Image getLabelImage() {
    String key = "image.label";
    Image image = ImageController.getImage(getBase(),this,key);
    return image;
  }

  
  /**
   * 
   * get the shell name
   * 
   */
  
  public Image getDecoratorImage() {
    String key = "image.decorator";
    Image image = ImageController.getImage(getBase(),this,key);
    return image;
  }

}

