package ca.aura.ui.swt;

import org.eclipse.swt.layout.FillLayout;


import ca.aabeka.util.DefaultGraph;
import ca.aabeka.util.Graph;
import ca.aura.artefacts.Artefact;
import ca.aura.artefacts.Doc;
import ca.aura.artefacts.SourceCode;
import ca.aura.artefacts.Webpage;
import ca.aura.project.Project;
import ca.aura.project.VCRProject;


import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * 
 * @author aforward
 *
 */
public class WhiteBoardViewTestUI extends AbstractTestUI {

  //```````````````````
  // all tests
  //```````````````````

  /**
   * 
   * the main runner
   * 
   */

  public static void main() {
    junit.textui.TestRunner.run(suite());
  }

  /**
   * 
   * the test suite to group tests together
   * 
   */

  public static Test suite() {
    return new TestSuite(WhiteBoardViewTestUI.class);
  }

  public static Object getObject() {
    return new SourceCode("1");  
  }

  public static Graph buildGraph() {
    
    Graph g = new DefaultGraph();
    
    Artefact a1,a2;
    
    a1 = new SourceCode("1");
    a2 = new SourceCode("2");
    
    g.add(a1,a2);

    a1 = new SourceCode("1");
    a2 = new Doc("3");
    
    g.add(a1,a2);
    
    a1 = new SourceCode("1");
    a2 = new Webpage("4");

    g.add(a1,a2);

    a1 = new SourceCode("1");
    a2 = new Webpage("5");

    g.add(a1,a2);    

    a1 = new SourceCode("1");
    a2 = new Webpage("6");

    g.add(a1,a2);    

    a1 = new SourceCode("1");
    a2 = new Webpage("7");

    g.add(a1,a2);    

    return g;    
  }
  

  //`````````````````````
  // tests
  //`````````````````````

  /**
   * 
   * test the creation of the graph
   * 
   */
  
  public void test_constructor() {

    getShell().setLayout(new FillLayout());
    WhiteBoardView wbView = WhiteBoardView.build(getShell());
    Project project = new VCRProject();
    wbView.setDepot(project.getDepot());
    //wbView.setGraph(getObject(),buildGraph());

    assert_gui("Testing Label Provider","Were they okay?");
    
    
    
  }  


}
