package ca.aura.xml;

import junit.framework.Test;
import junit.framework.TestSuite;

import ca.aabeka.xml.AbstractXmlConverterTest;
import ca.aabeka.xml.ObjectXmlConverter;
import ca.aura.project.DefaultProject;
import ca.aura.project.Project;


/**
 * 
 * @author aforward
 *
 */
public class ProjectXmlConverterTest extends AbstractXmlConverterTest {

  //```````````````````
  // all tests
  //```````````````````

  /**
   * 
   * the main runner
   * 
   */

  public static void main() {
    junit.textui.TestRunner.run(suite());
  }

  /**
   * 
   * the test suite to group tests together
   * 
   */

  public static Test suite() {
    return new TestSuite(ProjectXmlConverterTest.class);
  }


  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#getConverter()
   */
  public ObjectXmlConverter getConverter() {
    return new ProjectXmlConverter();
  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#test_load()
   */
  public void test_load() {
    String xml = "<project name='blah'><depot>depot.dep</depot><structure>structure.struct</structure><relationship>relationship.rel</relationship></project>";
    DefaultProject expected = new DefaultProject("blah");    
    expected.setDepotFile("depot.dep");
    expected.setStructureFile("structure.struct");
    expected.setRelationFile("relationship.rel");
    
    assert_load(xml, expected);
  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#test_build()
   */
  public void test_build() {
    String expected = "<project name='blah'><depot>depot.dep</depot><structure>structure.struct</structure><relationship>relationship.rel</relationship></project>";
    DefaultProject obj = new DefaultProject("blah");    
    obj.setDepotFile("depot.dep");
    obj.setStructureFile("structure.struct");
    obj.setRelationFile("relationship.rel");

    assert_build(obj, expected);
  }



}
