package ca.aura.xml;


import ca.aabeka.util.Debug;
import ca.aabeka.xml.AbstractXmlConverterTest;
import ca.aabeka.xml.ObjectXmlConverter;
import ca.aura.artefacts.AbstractArtefact;
import ca.aura.artefacts.sorting.Data;
import ca.aura.artefacts.sorting.Folder;
import ca.aura.project.Structure;

/**
 * 
 * @author aforward
 *
 */
public class StructureXmlConverterTest extends AbstractXmlConverterTest {

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#getConverter()
   */
  public ObjectXmlConverter getConverter() {
    return new StructureXmlConverter();
  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#test_load()
   */
  public void test_load() {
    String xml = "<structure><folder name='abc'><data id='1' />    <data id='2' /><data id='3' /><data id='4' /></folder></structure>";

    Structure expected = new Structure();

    Folder folder = new Folder("abc");
    Data d = new Data("");
    d.setData(new AbstractArtefact("1"));
    folder.add(d);
    
    d = new Data("");
    d.setData(new AbstractArtefact("2"));
    folder.add(d);

    d = new Data("");
    d.setData(new AbstractArtefact("3"));
    folder.add(d);
    
    d = new Data("");
    d.setData(new AbstractArtefact("4"));
    folder.add(d);    
    expected.add(folder);

    assert_load(xml,expected);  
  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#test_build()
   */
  public void test_build() {
    String expected = "<structure><folder name='abc'><data id='1' /><data id='2' /><data id='3' /><data id='4' /></folder></structure>";

    Structure structure = new Structure();

    Folder folder = new Folder("abc");
    Data d = new Data("");
    d.setData(new AbstractArtefact("1"));
    folder.add(d);
    
    d = new Data("");
    d.setData(new AbstractArtefact("2"));
    folder.add(d);

    d = new Data("");
    d.setData(new AbstractArtefact("3"));
    folder.add(d);
    
    d = new Data("");
    d.setData(new AbstractArtefact("4"));
    folder.add(d);    

    structure.add(folder);
    
    Debug.defaultPrintln(this,structure.getAllChildren());
    
    assert_build(structure,expected);
  }

}
