package ca.aura.algorithms;

import java.util.Iterator;

import ca.aabeka.util.Debug;
import ca.aabeka.util.Hashtable;
import ca.aura.artefacts.Artefact;

/**
 * 
 * @author aforward
 *
 */
public class ResultIterator implements Iterator {

  private Hashtable iter_;

  //`````````````````````
  // consturctor
  //`````````````````````

  /**
   * 
   * default
   * 
   */
  
  public ResultIterator(AuraAlgorithm alg) {
    init(alg);  
  }

  private void init(AuraAlgorithm alg) {
    iter_ = alg.getResults();
  }

  //`````````````````````
  // interface
  //`````````````````````

  /**
   * @see java.util.Iterator#hasNext()
   */
  public boolean hasNext() {
    Debug.defaultPrintln(this,"has Next? " + iter_.getKeys().hasNext());
    return iter_.getKeys().hasNext();
  }

  /**
   * @see java.util.Iterator#next()
   */
  public Object next() {

    Artefact smallestArtefact = null;            
    Double largestValue = null;
    
    Iterator keys = iter_.getKeys();
    while (keys.hasNext()) {
      Object key = keys.next();
      Double value = (Double)iter_.get(key);
      
      if (largestValue == null || value.doubleValue() > largestValue.doubleValue()) {
        smallestArtefact = (Artefact)key;
        largestValue = value;  
      }
    }
    
    iter_.removeKey(smallestArtefact);
    return smallestArtefact;

  }

  /**
   * @see java.util.Iterator#remove()
   */
  public void remove() {}



}
