package ca.aura.artefacts;



/**
 * 
 * @author aforward
 *
 */
public class AbstractAura implements Aura {

  private static final String DEFAULT_NAME = "";
  private static final Description DEFAULT_DESCR = new Description();

  private String name_;
  private Description descr_;
  
  private Artefact parent_;


  //`````````````````````
  // constructor
  //`````````````````````

  /**
   * 
   * default
   * 
   */
  
  public AbstractAura(String name) {
    init(name);  
  }

  private void init(String name) {
    name_ = name;  
  }

  //`````````````````````
  // Aura interface
  //`````````````````````

  /**
   * 
   * @see ca.aura.artefacts.Aura#getName()
   * 
   */
  public String getName() {
    return (name_ == null) ?  DEFAULT_NAME : name_;
  }

  /**
   * 
   * @see ca.aura.artefacts.Aura#getDescription()
   * 
   */
  public Description getDescription() {
    return (descr_ == null) ? DEFAULT_DESCR : descr_;
  }

  /**
   * 
   * @see ca.aura.artefacts.Aura#isPartOfAnArtefact()
   * 
   */
  public boolean isPartOfAnArtefact() {
    return parent_ == null;  
  }

  /**
   * 
   * @see ca.aura.artefacts.Aura#belongsTo()
   * 
   */
  public Artefact belongsTo() {
    return parent_;  
  }


  //`````````````````````
  // interface
  //`````````````````````

  /**
   * 
   * set the name
   * 
   */
  
  public void setName(String name) {
    name_ = name;  
  }

  /**
   * 
   * set the description
   * 
   */
  public void setDescription(Description descr) {
    descr_ = descr;  
  }

  /**
   * 
   * set the parent
   * 
   */
  public void setArtefact(Artefact parent) {
    parent_ = parent;  
  }

  //``````````````````````
  // object interface
  //``````````````````````
  
  /**
   * 
   * check for equality
   * 
   */
  
  public boolean equals(Object obj) {

    if (!(obj instanceof Aura)) {
      return false; 
    }
    
    Aura aura = (Aura)obj;
    
    if (!getName().equals(aura.getName())) {
      return false;  
    }
    
    return true;  
  }
  

  /**
   * 
   * the object as a string
   * 
   */
  
  public String toString() {
    return getName(); 
  }



}
