package ca.aura.artefacts;


/**
 * 
 * @author Andrew
 *
 */
public class Description  {

  private String text_;
  private String category_;
  
  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */
  
  public Description() {
    init("","");
  }

  /**
   * 
   * set the blurb
   * 
   */
  
  public Description(String blurb) {
    init("",blurb);  
  }

  /**
   * 
   * set the blurb and the type
   * 
   */
  
  public Description(String type, String blurb) {
    init(type,blurb);  
  }

  private void init(String type, String blurb) {
    category_ = type;
    text_ = blurb;  
  }

  //`````````````````````
  // iterface
  //`````````````````````

  /**
   * 
   * get the category
   * 
   */
  public String getCategory() {
    return category_;  
  }

  /**
   * 
   * set the category
   * 
   */
  public void setCategory(String category) {
    category_ = category;  
  }

  /**
   * 
   * get the text of the description
   * 
   */
  public String getText() {
    return text_;  
  }


  /**
   * 
   * set the text of the description
   * 
   */
  public void setText(String text) {
    text_ = text;  
  }
  

  //``````````````````````
  // object interface
  //``````````````````````

  /**
   * 
   * check for equality
   * 
   */

  public boolean equals(Object obj) {

    if (!(obj instanceof Description)) {
      return false;
    }

    Description descr = (Description) obj;

    if (!getCategory().equals(descr.getCategory())) {
      return false;
    }

    if (!getText().equals(descr.getText())) {
      return false;
    }

    return true;
  }

  /**
   * 
   * the object as a string
   * 
   */

  public String toString() {
    return getText();
  }  



}
