package ca.aura.artefacts.reports;

import java.util.Date;
import java.util.Iterator;

import ca.aura.artefacts.Artefact;
import ca.aura.artefacts.usage.Usage;

/**
 * 
 * @author aforward
 *
 */
public interface Report {

  
  /**
   * 
   * the date of the report
   * 
   */
  
  public Date getDate();
  

  /**
   * 
   * get an iterator of artefacts considered in this report
   * 
   */
  
  public Iterator getArtefacts();

  
  /**
   * 
   * is this artefact used?
   * 
   */
  
  public boolean isUsed(Artefact artefact);

  /**
   * 
   * get the iterator of usages of the artefact
   * 
   */
  
  public Iterator getUsage(Artefact artefact);


  /**
   * 
   * get last usage
   * 
   */
  public Usage getLastUsage(Artefact artefact);

}
