package ca.aura.project;

import java.util.Iterator;

import ca.aabeka.util.Vector;
import ca.aura.artefacts.usage.Usage;

/**
 * 
 * @author Andrew
 *
 */
public class History {

  Depot depot_;
  Vector history_;

  //``````````````````````
  // constructor
  //``````````````````````

  /**
   * 
   * default
   * 
   */
  
  public History() {
    init(new Depot());
  }
  
  /**
   * 
   * set the history default
   * 
   */
  
  public History(Depot depot) {
    init(depot);  
  }
  
  private void init(Depot depot) {
    depot_ = depot;
    history_ = new Vector();
  }


  //``````````````````````
  // interface
  //``````````````````````

  /**
   * 
   * set the depot
   * 
   */

  public void setDepot(Depot depot) {
    depot_ = depot;  
  }

  /**
   * 
   * get all the artefacts
   * 
   */

  public Iterator getArtefacts() {
    
    Vector artefacts = new Vector(false);
    
    Iterator iter = getHistory();
    while (iter.hasNext()) {
      Usage usage = (Usage)iter.next();
      String id = usage.getArtefactId();
      if (depot_.isArtefact(id)) {
        artefacts.add(depot_.getArtefact(id));    
      }
    }
    
    return artefacts.iterator();
  }

  /**
   * 
   * add a usage item
   * 
   */

  public boolean add(Usage usage) {
    
    for (int i=0; i < history_.size(); i++) {
      Usage tmpUsage = (Usage)history_.elementAt(i);

      if (usage.getDate().before(tmpUsage.getDate())) {
        history_.insertElementAt(usage, i);  
        return true;
      }
    }

    history_.addElement(usage);  
    return true;    
  }

  /**
   * 
   * get vector
   * 
   */

  public Iterator getHistory() {
    return history_.iterator();
  }


  //``````````````````````
  // object interface
  //``````````````````````
  
  /**
   * 
   * check for equality
   * 
   */
  
  public boolean equals(Object obj) {
    if (!(obj instanceof History)) {
      return false;	
    }
    
    History history = (History)obj;
    
    Vector h2 = new Vector();
    h2.addAll(history.getHistory());
    
    if (!history_.equals(h2)) {
      return false;  
    }
    	
    return true;	
  }
  
  /**
   * 
   * the object as a string
   * 
   */
  
  public String toString() {
    StringBuffer sb = new StringBuffer();
    Iterator iter = history_.iterator();
    while (iter.hasNext()) {
      Usage usage = (Usage)iter.next();
      sb.append(usage.getDate().toString() + " " );  
    }
    return sb.toString();
  }


}
