package ca.aura.project;

import ca.aabeka.util.Debug;
import ca.aabeka.util.StructuredNode;
import ca.aura.artefacts.sorting.Folder;

public class Structure extends StructuredNode {

  //``````````````````
  // constructor
  //``````````````````

  /**
   * 
   * default
   * 
   */

  public Structure() {
    super();
    init();
  }

  /**
   * 
   * give the domain a name
   * 
   */

  public Structure(String name) {
    super(name);
    init();
  }

  private void init() {
    addChildType(Folder.class);
  }

  //``````````````````````
  // object interface
  //``````````````````````

  /**
   * 
   * check for equality
   * 
   */

  public boolean equals(Object obj) {

    if (!(obj instanceof Structure)) {
      return false;
    }

    Structure structure = (Structure) obj;

    if (!toString().equals(structure.toString())) {
      return false;
    }

    if (!getAllChildren().equals(structure.getAllChildren())) {
      Debug.defaultPrintln(this,"different children:" + getAllChildren() + ":" + structure.getAllChildren() );
      return false;
        
    } 


    return true;
  }

  /**
   * 
   * the object as a string
   * 
   */

  public String toString() {
    return getName();
  }

}

