package ca.aura.ui.resources;

import ca.aabeka.util.Resource;

public class MaintenanceTaskResource extends Resource {

  private static MaintenanceTaskResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private MaintenanceTaskResource() { 
    init();
  }

  private void init() {
    add("ca.aura.resources.MaintenanceTask");
  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized MaintenanceTaskResource getDefault() {
    if (this_ == null) {
      this_ = new MaintenanceTaskResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````

  /**
   * 
   * get the Status name
   * 
   */
  
  public String getStatusName() {
    String key = "maintenanceTask.status";
    String defaultt = "";
    return getString(key,defaultt);  
  }

  /**
   * 
   * get the Status width
   * 
   */
  
  public int getStatusWidth() {
    String key = "maintenanceTask.status.width";
    int defaultt = 30;
    return getInt(key,defaultt);  
  }
  
  
  /**
   * 
   * get the Description name
   * 
   */
  
  public String getDescriptionName() {
    String key = "maintenanceTask.description";
    String defaultt = "Description";
    return getString(key,defaultt);  
  }

  /**
   * 
   * get the Description width
   * 
   */
  
  public int getDescriptionWidth() {
    String key = "maintenanceTask.description.width";
    int defaultt = 150;
    return getInt(key,defaultt);  
  }


  /**
   * 
   * get the Artefact name
   * 
   */
  
  public String getArtefactName() {
    String key = "maintenanceTask.artefact";
    String defaultt = "Artefact";
    return getString(key,defaultt);  
  }

  /**
   * 
   * get the Artefact width
   * 
   */
  
  public int getArtefactWidth() {
    String key = "maintenanceTask.artefact.width";
    int defaultt = 150;
    return getInt(key,defaultt);  
  }
  


  /**
   * 
   * get the Location name
   * 
   */
  
  public String getLocationName() {
    String key = "maintenanceTask.location";
    String defaultt = "Location";
    return getString(key,defaultt);  
  }

  /**
   * 
   * get the Location width
   * 
   */
  
  public int getLocationWidth() {
    String key = "maintenanceTask.location.width";
    int defaultt = 150;
    return getInt(key,defaultt);  
  }

  /**
   * 
   * > Popup Menu
   *   > Task Complete
   *   > Verify Task
   *   > Maintain Task
   *   > Ignore Task
   * 
   */
  
  public String getCompletedMenuName() {
    String key = "maintenanceTask.menu.complete";
    String defaultt = "This task is complete";
    return getString(key,defaultt);  
  }

  public String getNeedsVerificationMenuName() {
    String key = "maintenanceTask.menu.needsVerification";
    String defaultt = "This task needs to be verified";
    return getString(key,defaultt);  
  }

  
  public String getNeedsMaintenanceMenuName() {
    String key = "maintenanceTask.menu.needsMaintenance";
    String defaultt = "This task needs maintenance";
    return getString(key,defaultt);  
  }

  
  public String getIgnoreMenuName() {
    String key = "maintenanceTask.menu.ignore";
    String defaultt = "This task does not need maintenance";
    return getString(key,defaultt);  
  }

}
