package ca.aura.ui.resources;

import ca.aabeka.util.Resource;

public class ResultSetViewResource extends Resource {

  private static ResultSetViewResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private ResultSetViewResource() { 
    init();
  }

  private void init() {
    add("ca.aura.resources.resultSetView");
  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized ResultSetViewResource getDefault() {
    if (this_ == null) {
      this_ = new ResultSetViewResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````

  /**
   * 
   * get the maintenance column text
   * 
   */
 
  public String getMaintenanceText() {
    String key = "column.maintenance";
    String defaultt = "-";
    return getString(key,defaultt);  
  }


  /**
   * 
   * get the rank column text
   * 
   */
 
  public String getRankText() {
    String key = "column.rank";
    String defaultt = "-";
    return getString(key,defaultt);  
  }

  /**
   * 
   * get the maintenance column text
   * 
   */
 
  public String getNameText() {
    String key = "column.name";
    String defaultt = "Artefact Name";
    return getString(key,defaultt);  
  }


  /**
   * 
   * get the rank column text
   * 
   */
 
  public String getDescriptionText() {
    String key = "column.descr";
    String defaultt = "Description";
    return getString(key,defaultt);  
  }

}

