package ca.aura.algorithms.lrfu;

/**
 * 
 * @author aforward
 *
 */
public abstract class F {

  //`````````````````````
  // interface
  //`````````````````````


  /**
   * 
   * F(dt) = (1/p)^[dt*lamba]
   * 
   */

  public double calculate(int dt) {
    return Math.pow((1.0/p()),dt*lambda());  
  }

  public boolean isValid() {
    if (p() < 2) {
      return false;  
    }  
    
    if (lambda() < 0 || lambda() > 1) {
      return false;  
    }
    
    return true;
  }


  //`````````````````````
  // abstract interface
  //`````````````````````


  /**
   * 
   * get the p value
   * 
   */
  public abstract int p();


  /**
   * 
   * get the lambda value
   * 
   */
  public abstract double lambda();
   

}
