package ca.aura.algorithms.normalizer;

import ca.aabeka.math.Sequence;
import ca.aura.algorithms.rank.Rank;

/**
 * 
 * @author Andrew
 *
 */
public class IncreasingDropOffRankNormalizer extends RankNormalizer {

  //`````````````````
  // constructor
  //`````````````````

  /**
   * 
   * you cannot create a rank directly
   * 
   */
  
  public IncreasingDropOffRankNormalizer(Sequence sequence) {
    super(sequence);
  }

  /**
   * @see ca.aura.rank.RankNormalizer#getRankDivisions()
   */
  public double[] getRankDivisions() {
    double[] rankDivisions = new double[4];
    rankDivisions[0] = -2;
    rankDivisions[1] = -1;
    rankDivisions[2] = 0;
    rankDivisions[3] = 1;
    return rankDivisions;
  }

  /**
   * @see ca.aura.rank.RankNormalizer#getRanks()
   */
  public Rank[] getRanks() {
    Rank[] ranks = new Rank[5];
    ranks[0] = new Rank(1);
    ranks[1] = new Rank(2);
    ranks[2] = new Rank(3);
    ranks[3] = new Rank(4);    
    ranks[4] = new Rank(2);   
    return ranks;
  }

}
