package ca.aura.artefacts;

import java.io.File;
import java.util.Iterator;

/**
 * 
 * @author Andrew
 *
 */
public interface Artefact {

  /**
   * 
   * get the id of the artefact
   * 
   */
  
  public String getId();


  /**
   * 
   * get the name of the artefact
   * 
   */

  public String getName();

  
  /**
   * 
   * get a description of the artefact
   * 
   */
  
  public Description getDescription();

  
  /**
   * 
   * get the location of the artefact as a URL
   * 
   */
  
  public File getFile();


  /**
   * 
   * get the segments of an artefact... this includes the artefact's aura itself
   * 
   */
  
  public Iterator getAura();


  /**
   * 
   * how many aura elements does the artefact have?
   * 
   */
  
  public int numberOfAura();

}
