package ca.aura.artefacts.sorting;

import ca.aabeka.util.StructuredNode;
import ca.aura.artefacts.Artefact;
import ca.aura.artefacts.sorting.*;

/**
 * 
 * @author aforward
 *
 */
public class Data extends StructuredNode {

  private Artefact data_;

  //``````````````````
  // constructor
  //``````````````````

  /**
   * 
   * default
   * 
   */
  
  public Data() {
    super();
    init();  
  }

  /**
   * 
   * give the data a name
   * 
   */

  public Data(String name) {
    super(name);
    init();
  }

  /**
   * 
   * give the data a name and value
   * 
   */
  
  public Data(Artefact artefact) {
    super(artefact.getName());
    init();
    setData(artefact);  
  }


  private void init() {
    addParentType(Folder.class);
    addParentType(ResultSet.class);
  }


  /**
   * 
   * get the artefact
   * 
   */
  
  public Artefact getData() {
    return data_;  
  }

  /**
   * 
   * set teh artefact
   * 
   */
  public void setData(Artefact artefact) {
    data_ = artefact;  
  }


  /**
   * 
   * does the data have it?
   * 
   */
  public boolean hasData() {
    return data_ != null;  
  }

}

