package ca.aura.artefacts.usage;

import java.util.Date;

import ca.aabeka.util.DateAndTime;

/**
 * 
 * @author Andrew
 *
 */
public class DefaultUsage implements Usage {

  private String artefactId_;
  private Date date_;
  private String comment_;
  private String task_;
  private String role_;
  

  //``````````````````````
  // constructor
  //``````````````````````

  /**
   * 
   * default
   * 
   */
  
  public DefaultUsage() {
    init("",new Date(),"");  
  }

  /**
   * 
   * default
   * 
   */

  public DefaultUsage(String id) {
    Date date = new Date();
    String comment = "";
    init(id,date,comment);        
  }



  /**
   * 
   * set the comment
   * 
   */
  
  public DefaultUsage(String artefactId, String comment) {
    Date date = new Date();
    init(artefactId, date,comment);
  }

  /**
   * 
   * set the comment and the date
   * 
   */

  public DefaultUsage(String artefactId, Date date) {
    String comment = "";
    init(artefactId, date,comment);  
  }

  /**
   * 
   * set the comment and the date
   * 
   */

  public DefaultUsage(String artefactId, Date date, String comment) {
    init(artefactId, date,comment);  
  }

  private void init(String artefactId, Date date, String comment) {
    artefactId_ = artefactId;
    date_ = date;
    comment_ = comment;
  }

  //``````````````````````
  // Utilize interface
  //``````````````````````

  /**
   * 
   * @see ca.aura.whiteboard.Utilize#getTask()
   * 
   */

  public String getTask() {
    return task_;  
  }  

  /**
   * 
   * @see ca.aura.whiteboard.Utilize#getRole()
   * 
   */  
  public String getRole() {
    return role_;  
  }


  /**
   * 
   * @see ca.aura.whiteboard.Utilize#getArtefact()
   * 
   */
  public String getArtefactId() {
    return artefactId_;
  }

  /**
   * 
   * @see ca.aura.utilize.Utilize#getDate()
   * 
   */
  public Date getDate() {
    return date_;
  }

  /**
   * 
   * @see ca.aura.utilize.Utilize#getComment()
   * 
   */
  public String getComment() {
    return comment_;
  }


  //`````````````````````
  // interface
  //`````````````````````

  /**
   * 
   * set the task
   * 
   */

  public void setTask(String task) {
    task_ = task;  
  }  

  /**
   * 
   * set the role
   * 
   */  
  public void setRole(String role) {
    role_ = role;
  }


  /**
   * 
   * set the id 
   * 
   */
  public void setArtefactId(String id) {
    artefactId_ = id;
  }

  /**
   * 
   * @see ca.aura.utilize.Utilize#getDate()
   * 
   */
  public void setDate(String date) {
    date_ = DateAndTime.getDefault().getDate(date);
  }

  /**
   * 
   * set the comment
   * 
   */

  public boolean setComment(String comment) {
    if (comment == null) {
      return false;  
    }  
    comment_ = comment;
    return true;
  }

  /**
   * 
   * @see ca.aura.utilize.Utilize#hasBeenUsed()
   * 
   */  
  
  public boolean hasBeenUsed() {
    return true;  
  }

}
  