package ca.aura.artefacts.usage;



/**
 * 
 * @author Andrew
 *
 */
public class UsageManager implements UsageSemantic{

  protected static final String SEARCH = "search";
  protected static final String BROWSE = "browse";
  protected static final String VERIFY = "verify";
  protected static final String VALIDATE = "validate";
  protected static final String MAINTAIN = "maintain";


  private UsageSemantic usage_;
  
  //`````````````````````
  // constructor
  //`````````````````````

  /**
   * 
   * default
   * 
   */

  public UsageManager() {
    init();  
  }

  private void init() {
    usage_ = Everything.getDefault();
  }

  //`````````````````````
  // interface
  //`````````````````````

  
  /**
   * 
   * consulting documents
   * 
   */
  
  public void setConsulting() {
    usage_ = Consult.getDefault();  
  }


  /**
   * 
   * consulting documents
   * 
   */
  
  public void setMaintaining() {
    usage_ = Maintain.getDefault();  
  }

  


  //`````````````````````
  // UsageSemantic interface
  //`````````````````````

  /**
   * 
   * @see ca.aura.artefacts.usage.UsageSemantic#isApplicable(Usage)
   * 
   */

  public boolean isApplicable(Usage usage) {
    return usage_.isApplicable(usage);
  }  
 



}
