package ca.aura.project;

import java.util.Iterator;

import ca.aabeka.util.Hashtable;
import ca.aura.artefacts.Artefact;

/**
 * 
 * @author aforward
 *
 */
public class Depot {

  private Hashtable artefacts_;

  //`````````````````````
  // construtor
  //`````````````````````

  /**
   * 
   * default
   * 
   */
  
  public Depot() {
    init();  
  }

  private void init() {
    artefacts_ = new Hashtable();  
  }


  //`````````````````````
  // inteface
  //`````````````````````

  /**
   * 
   * is this id an artefact?
   * 
   */

  public boolean isArtefact(String id) {
    return artefacts_.containsKey(id);  
  }


  /**
   * 
   * get the artefact
   * 
   */
  
  public Artefact getArtefact(String id) {
    return (Artefact)artefacts_.get(id);    
  }


  /**
   * 
   * add an artefact
   * 
   */
  public void add(Artefact artefact) {
    artefacts_.put(artefact.getId(),artefact);
  }

  /**
   * 
   * add a depot
   * 
   */
  public void addAll(Depot depot) {
    
    Iterator iter = depot.getArtefacts();
    while (iter.hasNext()) {
      Artefact artefact = (Artefact)iter.next();
      artefacts_.put(artefact.getId(), artefact);  
    }
  }

  /**
   * 
   * add to a depot
   * 
   */
  
  public void addFile(String[] files, String type) {
  
    
  }

  /**
   * 
   * get all the artefacts
   * 
   */
  public Iterator getArtefacts() {
    return artefacts_.getValues();  
  }


}
