package ca.aura.resources;

import java.io.File;

import ca.aabeka.util.FileInfo;
import ca.aabeka.util.Resource;

public class FileResource extends Resource {

  private static FileResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private FileResource() { 
    init();
  }

  private void init() {
    add("ca.aura.resources.file");
  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized FileResource getDefault() {
    if (this_ == null) {
      this_ = new FileResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````
  
  /**
   * 
   * get the default file launcher string
   * 
   */
  
  public String getLaunchCommand(File f) {
    
    if (!f.exists()) {
      return "";  
    }
    
    String key = "file.launcher.";  
    String defaultKey = key + "default";
    String defaultt = "rundll32 url.dll,FileProtocolHandler"; 

    String filename = f.getAbsolutePath();    

    if (!FileInfo.hasExtension(filename)) {
      return getString(defaultKey, defaultt) + " " + filename;  
    }

    String ext = FileInfo.getExtension(filename);
    String launchKey = key + ext;    
    return getString(launchKey,defaultt)  + " " + filename;
  }    

}
