package ca.aura.resources;

import ca.aabeka.util.Resource;

public class RankResource extends Resource {

  private static RankResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private RankResource() { 
    init();
  }

  private void init() {
    add("ca.aura.resources.rank");
  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized RankResource getDefault() {
    if (this_ == null) {
      this_ = new RankResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````
  
  /**
   * 
   * Over how long should we determine the average number of page accesses?
   * 
   */
  
  public int getLRD_K_Interval() {
    String key = "lrd.k.days";
    int defaultt = 30;
    int days = getInt(key,defaultt);
    return days;
  }

  /**
   * 
   * Over how many days do we apply the temporal decay?
   * 
   */

  public int getLRD_TemporalDecay_Interval() {
    String key = "lrd.temporalDecay.days";
    int defaultt = 30;
    int days = getInt(key,defaultt);
    return days;  
  }

  /**
   * 
   * get the minimum rank
   * 
   */

  public int getMinimumRank() {
    String key = "rank.minimum";
    int defaultt = 1;
    int days = getInt(key,defaultt);
    return days;  
  }

  /**
   * 
   * get the maximum rank
   * 
   */
  public int getMaximumRank() {
    String key = "rank.maximum";
    int defaultt = 4;
    int days = getInt(key,defaultt);
    
    if (days < getMinimumRank()) {
      return getMinimumRank();  
    }

    return days;      
  }


}
