package ca.aura.resources;

import ca.aabeka.util.Debug;
import ca.aabeka.util.Resource;

public class RelevanceResource extends Resource {

  private static RelevanceResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private RelevanceResource() { 
    init();
  }

  private void init() {
    add("tmp");
    add("ca.aura.resources.relevance");
    Debug.defaultPrintln(this,getResource(0));
    Debug.defaultPrintln(this,setString("a","b"));

  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized RelevanceResource getDefault() {
    if (this_ == null) {
      this_ = new RelevanceResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````
  
  /**
   * 
   * Get the age factor
   * 
   */
  
  public int getAgeFactor() {
    String key = "relevance.factor.age";
    return getFactor(key);
  }

  /**
   * 
   * Get the authoritative factor
   * 
   */
  
  public int getAuthoritativeFactor() {
    String key = "relevance.factor.authoritative";
    return getFactor(key);
  }

  /**
   * 
   * Get the age factor
   * 
   */
  
  public int getReferenceIntegrityFactor() {
    String key = "relevance.factor.ri";
    return getFactor(key);
  }


  //``````````````````````
  // protected
  //``````````````````````

  /**
   * 
   * get factor
   * 
   */
  
  public int getFactor(String key) {
    int factor = getInt(key,40);
    return factor;
  }



}
