package ca.aura.resources;

import java.util.Vector;

import ca.aabeka.util.Resource;

public class RoleResource extends Resource {

  private static RoleResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private RoleResource() { 
    init();
  }

  private void init() {
    add("ca.aura.resources.role");
  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized RoleResource getDefault() {
    if (this_ == null) {
      this_ = new RoleResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````

  /**
   * 
   * get the default task
   * 
   */

  public String getDefaultRole() {
    String key = "role.list";
    String defaultt = "developer";
    Vector tasks = getList(key);
    
    if (tasks.size() == 0) {
      return defaultt;  
    }
    
    return (String)tasks.elementAt(0);
  }

  /**
   * 
   * normalize the task
   * 
   */

  public String normalize(String task) {
    String key = "role.list";
    Vector tasks = getList(key);
    
    if (tasks.size() == 0) {
      return getDefaultRole();  
    }
    
    if (!tasks.contains(task)) {
      return (String)tasks.elementAt(0);
    }
    
    return task;
  }


}
