package ca.aura.ui.resources;

import org.eclipse.jface.resource.ImageDescriptor;

import ca.aabeka.ui.ImageController;
import ca.aabeka.util.Resource;

public class ArtefactResource extends Resource {

  private static ArtefactResource this_;

  //``````````````````````
  // constructor
  //``````````````````````
  
  /**
   * 
   * default
   * 
   */

  private ArtefactResource() { 
    init();
  }

  private void init() {
    add("ca.aura.resources.ui_artefact");
  }

  /**
   * 
   * get the singleton resource
   * 
   */
  
  public static synchronized ArtefactResource getDefault() {
    if (this_ == null) {
      this_ = new ArtefactResource();  
    }
    return this_;
  }


  //``````````````````````
  // interface
  //``````````````````````

  /**
   * 
   * get the aura image descriptor
   * 
   */

  public ImageDescriptor getAuraImageDescriptor() {
    String key = "aura.image";
    return ImageController.getImageDescriptor(getBase(),this,key);  
  }

  /**
   * 
   * get the folder image descriptor
   * 
   */

  public ImageDescriptor getFolderImage() {
    String key = "folder.image";
    return ImageController.getImageDescriptor(getBase(),this,key);    
  }


  /**
   * 
   * get the normal document image descriptor
   * 
   */

  public ImageDescriptor getDocImageDescriptor() {
    String key = "document.image";
    return ImageController.getImageDescriptor(getBase(),this,key);  
  }

  /**
   * 
   * get the highlighted document image descriptor
   * 
   */

  public ImageDescriptor getDocHighlightImageDescriptor() {
    String key = "document.image.highlight";
    return ImageController.getImageDescriptor(getBase(),this,key);  
  }




  /**
   * 
   * get the normal source code image descriptor
   * 
   */

  public ImageDescriptor getSourceCodeImageDescriptor() {
    String key = "sourcecode.image";
    return ImageController.getImageDescriptor(getBase(),this,key);    
  }


  /**
   * 
   * get the highlighted source code image descriptor
   * 
   */

  public ImageDescriptor getSourceCodeHighlightImageDescriptor() {
    String key = "sourcecode.image.highlight";
    return ImageController.getImageDescriptor(getBase(),this,key);  
  }

  /**
   * 
   * get the normal document image descriptor
   * 
   */

  public ImageDescriptor getWebpageImageDescriptor() {
    String key = "webpage.image";
    return ImageController.getImageDescriptor(getBase(),this,key);    
  }

  /**
   * 
   * get the highlighted document image descriptor
   * 
   */

  public ImageDescriptor getWebpageHighlightImageDescriptor() {
    String key = "webpage.image.highlight";
    return ImageController.getImageDescriptor(getBase(),this,key);  
  }



  /**
   * 
   * get the normal javadoc ImageDescriptor
   * 
   */

  public ImageDescriptor getJavaDocImageDescriptor() {
    String key = "javadoc.image";
    return ImageController.getImageDescriptor(getBase(),this,key);    
  }


  /**
   * 
   * get the highlighted javadoc ImageDescriptor
   * 
   */

  public ImageDescriptor getJavaDocHighlightImageDescriptor() {
    String key = "javadoc.image.highlight";
    return ImageController.getImageDescriptor(getBase(),this,key);  
  }



  /**
   * 
   * get the normal junit report image
   * 
   */

  public ImageDescriptor getJunitReportImageDescriptor() {
    String key = "junitreport.image";
    return ImageController.getImageDescriptor(getBase(),this,key);    
  }


  /**
   * 
   * get the highlighted junit report image
   * 
   */

  public ImageDescriptor getJunitReportHighlightImageDescriptor() {
    String key = "junitreport.image.highlight";
    return ImageController.getImageDescriptor(getBase(),this,key);  
  }








  /**
   * 
   * get the browse menu item text
   * 
   */
  public String getBrowseMenuItemText() {
    String key = "menu.browse";
    String defaultt = "Browse this document";
    return getString(key,defaultt);
  }

  /**
   * 
   * get the browse menu item text
   * 
   */
  public String getAddCommentMenuItemText() {
    String key = "menu.addComment";
    String defaultt = "Add a comment";
    return getString(key,defaultt);
  }

  /**
   * 
   * get the search menu item text
   * 
   */
  public String getSearchMenuItemText() {
    String key = "menu.search";
    String defaultt = "Search this document";
    return getString(key,defaultt);
  }

}

