package ca.aura.ui.swt;

import java.util.Iterator;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

/**
 * @author Andrew
 *
 */
public class InputUI {

  public static int DEFAULT_STYLE = SWT.BORDER;

  private static int GENERAL_TASK_TITLE_STYLE = SWT.SHADOW_IN;
  private static int GENERAL_TASK_AREA_STYLE = SWT.DROP_DOWN;

  private static int MY_ROLE_TITLE_STYLE = GENERAL_TASK_TITLE_STYLE;
  private static int MY_ROLE_AREA_STYLE = GENERAL_TASK_AREA_STYLE;


  private Composite self_;

  private Label myRoleTitle_;
  private Combo myRoleArea_;

  private Label generalTaskTitle_;
  private Combo generalTaskArea_;

  //```````````````
  // constructor
  //```````````````

  /**
   * 
   * default
   * 
   */
  

  protected InputUI(Composite composite) {
    init(composite);  
  }

  private void init(Composite composite) {
    
    self_ = new Composite(composite,SWT.NULL);

    GridLayout gridLayout = new GridLayout();
    gridLayout.numColumns = 1;
    self_.setLayout(gridLayout);

    myRoleTitle_ = buildMyRoleTitle(self_);
    myRoleArea_ = buildMyRoleArea(self_);

    generalTaskTitle_ = buildGeneralTaskTitle(self_);
    generalTaskArea_ = buildGeneralTaskArea(self_);

  }

  /**
   * 
   * build up the composite
   * 
   */

  public static InputUI build(Composite composite) {
    return new InputUI(composite);
  }
  

  //``````````````````
  // protected
  //``````````````````

  /**
   * 
   * get the general task title
   * 
   */

  protected Label buildGeneralTaskTitle(Composite self) {
    Label lbl = new Label(self, GENERAL_TASK_TITLE_STYLE);
    lbl.setText("My Task");
    return lbl;
  }


  /**
   * 
   * get the general task area
   * 
   */

  protected Combo buildGeneralTaskArea(Composite self) {
    Combo task = new Combo(self, GENERAL_TASK_AREA_STYLE);
    return task;
  }

  /**
   * 
   * set the general task items
   * 
   */

  protected void setGeneralTasks(Iterator iter) {
    setChoices(generalTaskArea_,iter);
  }

  /**
   * 
   * get the my role title
   * 
   */

  protected Label buildMyRoleTitle(Composite self) {
    Label lbl = new Label(self, MY_ROLE_TITLE_STYLE);
    lbl.setText("My Role");
    return lbl;
  }

  /**
   * 
   * get the my role area
   * 
   */

  protected Combo buildMyRoleArea(Composite self) {
    Combo role = new Combo(self, MY_ROLE_AREA_STYLE);
    role.setTextLimit(30);
    return role;
  }

  /**
   * 
   * set the roles items
   * 
   */

  protected void setMyRoles(Iterator iter) {
    setChoices(myRoleArea_,iter);
  }


  /**
   * 
   * set the combo items
   * 
   */

  protected void setChoices(Combo task, Iterator iter) {
    task.removeAll();
    while(iter.hasNext()) {
      String atask = iter.next().toString();
      task.add(atask);  
    }   
  }




}
