package ca.aura.ui.swt;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import ca.aura.artefacts.sorting.Data;
import ca.aura.artefacts.sorting.ResultSet;


/**
 * 
 * @author aforward
 *
 */
public class ResultSetContentProvider implements ITreeContentProvider {

  private static final Object[] NO_CHILDREN = new Object[]{};

  /**
   * @see org.eclipse.jface.viewers.ITreeContentProvider#getChildren(Object)
   */
  public Object[] getChildren(Object obj) {
    
    if (obj instanceof ResultSet) {
      return ((ResultSet)obj).getAllChildren().toArray();  
    } 
    
    if (obj instanceof Data) {
      return NO_CHILDREN;
    }

    return NO_CHILDREN;
  }

  /**
   * @see org.eclipse.jface.viewers.ITreeContentProvider#getParent(Object)
   */
  public Object getParent(Object obj) {

    if (obj instanceof ResultSet) {
      return null;  
    } 
    
    if (obj instanceof Data) {
      return ((Data)obj).getParent();
    }

    return null;
  }

  /**
   * @see org.eclipse.jface.viewers.ITreeContentProvider#hasChildren(Object)
   */
  public boolean hasChildren(Object obj) {
    return getChildren(obj).length > 0;
  }

  /**
   * @see org.eclipse.jface.viewers.IStructuredContentProvider#getElements(Object)
   */
  public Object[] getElements(Object obj) {
    return getChildren(obj);
  }

  /**
   * @see org.eclipse.jface.viewers.IContentProvider#dispose()
   */
  public void dispose() {}

  /**
   * @see org.eclipse.jface.viewers.IContentProvider#inputChanged(Viewer, Object, Object)
   */
  public void inputChanged(Viewer arg0, Object arg1, Object arg2) {}

}
