package ca.aura.xml;

import org.jdom.Element;

import ca.aabeka.xml.XmlConverterUtil;
import ca.aura.artefact.components.Description;
import ca.aura.artefact.components.Location;

/**
 * 
 * @author Andrew
 *
 */
public class XmlManager {

  private static final String ELEMENT_NAME = "name";
  private static final String ELEMENT_REFERENCES = "references";

  private static final String ATTRIBUTE_CATEGORY = "category";
  private static final String ATTRIBUTE_ID = "id";


  /**
   * 
   * get the id of the artefact
   * < id="asdf" />
   * 
   */

  public String getId(Element artefact) {
    return XmlConverterUtil.getAttribute(artefact, ATTRIBUTE_ID);
  }

  /**
   * 
   * get the name of the artefact
   * <name>blah</name>
   * 
   */

  public String getName(Element artefact) {
    return XmlConverterUtil.getChildText(artefact,ELEMENT_NAME);
  }


  /**
   * 
   * get a description 
   * 
   */
  
  public static Description getDescription(Element artefact) {
    
    if (artefact == null) {
      return new Description();  
    }  
    
    DescriptionXmlConverter descrConverter = new DescriptionXmlConverter();

    Element descr = artefact.getChild(descrConverter.getElementName());
    
    if (descr == null) {
      return new Description();  
    }
    
    
    return (Description)descrConverter.load(descr);
    
  }


  /**
   * 
   * get the location
   * 
   */

  public static Location getLocation(Element artefact) {

    if (artefact == null) {
      return new Location();  
    }  
    
    Element location = artefact.getChild(LocationXmlConverter.ELEMENT_ROOT);
    
    if (location == null) {
      return new Location();  
    }    
    
    LocationXmlConverter locationConverter = new LocationXmlConverter();
    return (Location)locationConverter.load(location);
  }


}
