package ca.aura.plugin;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.ResourceBundle;

import org.eclipse.core.resources.IWorkspace;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IPluginDescriptor;
import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.ui.plugin.AbstractUIPlugin;

import ca.aura.ui.resources.ArtefactResource;


public class AuraPlugin extends AbstractUIPlugin {

  private static AuraPlugin this_;

  //``````````````
  // constructor
  //``````````````

 /**
  * 
  * default
  * 
  */

  public AuraPlugin(IPluginDescriptor descriptor) {
    super(descriptor);
    this_ = this;
    
    ArtefactResource.getDefault().setBase(descriptor.getInstallURL());
    
  }


 /**
  * 
  * shared instance
  * 
  */
 
  public static AuraPlugin getDefault() {
    return this_;
  }

 /**
  * 
  * the workspace
  * 
  */
 
  public static IWorkspace getWorkspace() {
    return ResourcesPlugin.getWorkspace();
  }


  public ImageDescriptor getImageDescriptor(String key) {
    try {
      URL url= new URL(getDescriptor().getInstallURL(), "icons/" + key + ".gif");
      return ImageDescriptor.createFromURL(url);
    } catch (MalformedURLException e) {
      return ImageDescriptor.getMissingImageDescriptor();
    }
  }

  /**
   * Returns the plugin's resource bundle,
   */
  public ResourceBundle getResourceBundle() {
    return getDescriptor().getResourceBundle();
  }
}
