package ca.aura.algorithms;

import ca.aabeka.util.DefaultGraph;
import ca.aabeka.util.Graph;
import ca.aabeka.util.Hashtable;
import ca.aabeka.util.Vector;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * 
 * @author aforward
 *
 */
public class AuthoritativeSourcesTest extends TestCase {


  //```````````````````
  // all tests
  //```````````````````

  /**
   * 
   * the main runner
   * 
   */

  public static void main() {
    junit.textui.TestRunner.run(suite());
  }

  /**
   * 
   * the test suite to group tests together
   * 
   */

  public static Test suite() {
    return new TestSuite(AuthoritativeSourcesTest.class);
  }


  //`````````````````````
  // assertions
  //`````````````````````

  /**
   * 
   * assert getAuthorities
   * 
   */
  
  public void assert_getAuthorities(Vector subset, Graph g, Hashtable expected) {
    AuthoritativeSources asa = new  AuthoritativeSources(subset, g,1);
    Hashtable actual = asa.getResults();
    assertEquals(expected,actual);    
  }



  //```````````````````
  // tests
  //```````````````````

  /**
   * 
   * the whole things :-)
   * 
   */

  public void test_doit() {
  
    Vector subset = new Vector();
    subset.add("a");
    subset.add("b");
    
    Graph g = new DefaultGraph();
    g.add("a", "b");
    g.add("a", "c");
    g.add("b", "c");
    g.add("d", "c");
    
    Hashtable expected = new Hashtable();
    expected.put("a",new Double(-1));
    expected.put("b",new Double(0));
    expected.put("c",new Double(1));
    
    assert_getAuthorities(subset,g,expected);
  }

}
