package ca.aura.algorithms.rank;

import java.util.Date;

import ca.aabeka.util.Hashtable;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * 
 * @author Andrew
 *
 */
public class ParamtersTest extends TestCase{

  //```````````````````
  // all tests
  //```````````````````
  
  /**
   * 
   * the main runner
   * 
   */
  
  public static void main () {
    junit.textui.TestRunner.run (suite());
  }
  
  /**
   * 
   * the test suite to group tests together
   * 
   */
  
  public static Test suite() {
    return new TestSuite(ParamtersTest.class);
  }


  //```````````````````
  // assertions
  //```````````````````

  /**
   * 
   * assert getWeight
   * 
   */

  public void assert_getWeight(Hashtable hash, String id, double expected) {
    Parameters settings = new Parameters(hash);
    double actual = settings.getWeight(id);  
    assertEquals(expected,actual,0.1);
  }

  /**
   * 
   * assert calculateTotalWeight
   * 
   */

  public void assert_calculateTotalWeight(Hashtable hash, double expected) {
    Parameters settings = new Parameters(hash);
    double actual = settings.calculateTotalWeight();  
    assertEquals(expected,actual,0.1);
  }

  /**
   * 
   * assert getTotalWeight
   * 
   */

  public void assert_getTotalWeight(Hashtable hash, double expected) {
    Parameters settings = new Parameters(hash);
    double actual = settings.getTotalWeight();  
    assertEquals(expected,actual,0.1);
    
    int delta = 4;
    settings.setWeight("d",delta);
    actual = settings.getTotalWeight();
    assertEquals(expected+delta, actual, 0.1);
    
    
  }

  //```````````````````
  // tests
  //```````````````````

  /**
   * 
   * calculateTotalWeight
   * 
   */

  public void test_calculateTotalWeight() {
  
    Hashtable hash = new Hashtable();
    hash.put("a",new Double(1));  
    hash.put("b",new Double(2));  
    hash.put("c",new Double(3));  
    
    double expected = 6;
    assert_calculateTotalWeight(hash,expected);
    
  }

  /**
   * 
   * getTotalWeight
   * 
   */

  public void test_getTotalWeight() {
  
    Hashtable hash = new Hashtable();
    hash.put("a",new Double(1));  
    hash.put("b",new Double(2));  
    hash.put("c",new Double(3));  
    
    double expected = 6;
    assert_getTotalWeight(hash,expected);
    
  }

  /**
   * 
   * getWeight
   * 
   */

  public void test_getWeight() {
  
    Hashtable hash = new Hashtable();
    hash.put("a",new Double(1));  
    hash.put("b",new Double(2));  
    hash.put("c",new Double(3));  
    
    String id = "a";
    double expected = 1;
    assert_getWeight(hash,id, expected);
    
  }

}
