package ca.aura.artefacts.usage;

import java.util.Vector;

import ca.aabeka.util.DateAndTime;
import ca.aabeka.util.Debug;
import ca.aura.artefacts.AbstractArtefact;
import ca.aura.project.History;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * 
 * @author Andrew
 *
 */
public class HistoryTest extends TestCase {


  //```````````````````
  // all tests
  //```````````````````
  
  /**
   * 
   * the main runner
   * 
   */
  
  public static void main () {
    junit.textui.TestRunner.run (suite());
  }
  
  /**
   * 
   * the test suite to group tests together
   * 
   */
  
  public static Test suite() {
    return new TestSuite(HistoryTest.class);
  }


  //``````````````````````
  // setUp
  //``````````````````````
  
  
  
  /**
   * 
   * make my own artefact
   * 
   */
  

  public class TmpArtefact extends AbstractArtefact {
    
    public TmpArtefact(String id) {
      super(id);
    }    
  }

  //``````````````````````
  // assertions
  //``````````````````````
  
  /**
   * 
   * assert the sorting is working
   * 
   */
  
  public void assert_sorting(Vector unsorted, Vector sorted) {
    
    History actualHistory = new History();
    History expectedHistory = new History();
    
    assertEquals(unsorted.size(), sorted.size());
    
    for (int i=0; i<unsorted.size(); i++) {
      actualHistory.add((Usage)unsorted.elementAt(i));
      expectedHistory.add((Usage)sorted.elementAt(i));
    }

    Debug.defaultPrintln(this,expectedHistory);
    Debug.defaultPrintln(this,actualHistory);
    assertEquals(expectedHistory, actualHistory);

  }

  //``````````````````````
  // tests
  //``````````````````````
  
  /**
   * 
   * test the sorting
   * 
   */  

  public void test_sorting() {
  
  
    Usage usage1 = new DefaultUsage("1", DateAndTime.add(-5));
    Usage usage2 = new DefaultUsage("2", DateAndTime.add(-4));
    Usage usage3 = new DefaultUsage("3", DateAndTime.add(-3));
    Usage usage4 = new DefaultUsage("4", DateAndTime.add(-2));
    Usage usage5 = new DefaultUsage("5", DateAndTime.add(0));                
    Usage usage6 = new DefaultUsage("6", DateAndTime.add(2));                  

    Vector sorted = new Vector();
    sorted.addElement(usage1);
    sorted.addElement(usage2);
    sorted.addElement(usage3);    
    sorted.addElement(usage4);
    sorted.addElement(usage5);
    sorted.addElement(usage6);           
    
    Vector unsorted = new Vector();
    unsorted.addElement(usage6);
    unsorted.addElement(usage3);
    unsorted.addElement(usage2);
    unsorted.addElement(usage1);
    unsorted.addElement(usage5);
    unsorted.addElement(usage4);
    
    assert_sorting(unsorted, sorted);
            
    
  }


}

