package ca.aura.ui.swt;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;

import junit.framework.TestCase;


/**
 * 
 * @author aforward
 *
 */
public class AbstractTestUI extends TestCase{

  private Shell shell_;
  private Display display_;


  //```````````````````
  // setUp
  //```````````````````

  public void setUp() {
    display_ = new Display ();
    shell_ = new Shell (display_);    
  }

  public void start() {
    shell_.open();
    while (!shell_.isDisposed ()) {
        if (!display_.readAndDispatch ()) display_.sleep ();
    }
    display_.dispose ();     
  }

  public void tearDown() {
    display_.dispose ();    
  }

  //```````````````````
  // interface
  //```````````````````  

  public Shell getShell() {
    return shell_;  
  }

  //```````````````````
  // assertions
  //```````````````````

  /**
   * 
   * default assert what the gui should do
   * 
   */

  public void assert_gui() {
    assert_gui("Viewer Test","Did everything look okay?");  
  }

  /**
   * 
   * assert the gui does what it should
   * 
   */

  public void assert_gui(String text, String message, int expected) {
    MessageBox box = new MessageBox(shell_,SWT.YES | SWT.NO);    
    box.setMessage(message);
    box.setText(text);
    start();
    int actual = box.open();
    assertEquals(expected,actual);
  }

  /**
   * 
   * assert the gui does what it should
   * 
   */

  public void assert_gui(String text, String message) {
    assert_gui(text,message,SWT.YES);
  }

}
