package ca.aura.ui.swt;

import java.io.File;

import org.eclipse.swt.layout.FillLayout;

import ca.aabeka.xml.XmlStream;
import ca.aura.artefacts.AbstractArtefact;
import ca.aura.artefacts.Description;
import ca.aura.artefacts.Doc;
import ca.aura.artefacts.SourceCode;
import ca.aura.artefacts.Webpage;
import ca.aura.artefacts.sorting.Data;
import ca.aura.artefacts.sorting.ResultSet;
import ca.aura.project.Depot;
import ca.aura.project.History;
import ca.aura.project.Project;
import ca.aura.project.VCRProject;
import ca.aura.xml.DepotXmlConverter;
import ca.aura.xml.HistoryXmlConverter;
import ca.aura.xml.ProjectXmlConverter;

import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * 
 * @author aforward
 *
 */
public class ResultSetViewTestUI extends AbstractTestUI {

  //```````````````````
  // all tests
  //```````````````````

  /**
   * 
   * the main runner
   * 
   */

  public static void main() {
    junit.textui.TestRunner.run(suite());
  }

  /**
   * 
   * the test suite to group tests together
   * 
   */

  public static Test suite() {
    return new TestSuite(ResultSetViewTestUI.class);
  }

  //`````````````````````
  // setUp
  //`````````````````````

  /**
   * 
   * create a Tmp Artefact
   * 
   */

  public class Tmp extends AbstractArtefact {
  
    public Tmp(String id, String name, String descr, String type) {
      super(id);
      super.setName(name);
      super.setDescription(new Description(type,descr));
    }  
    
    
  }

  public static ResultSet buildResultSet() {
    ResultSet rs = new ResultSet("name");
    Data d;
    AbstractArtefact artefact;
        

    d = new Data("d1");
    artefact = new SourceCode("1");
    artefact.setName("Vector");
    artefact.setDescription(new Description("I have a lot more to say then that"));
    d.setData(artefact);
    rs.add(d);

    d = new Data("d2");
    artefact = new Webpage("2");
    artefact.setName("the world wide web");
    artefact.setDescription(new Description("More garbel garbel garbel"));
    d.setData(artefact);
    rs.add(d);

    d = new Data("d3");
    artefact = new Doc("3");
    artefact.setName("the document");
    artefact.setDescription(new Description("Me, myself and Irene"));
    d.setData(artefact);
    rs.add(d);

    d = new Data("d4");
    artefact = new Webpage("4");
    artefact.setName("more www ship");
    artefact.setDescription(new Description("Yo, what is up?"));
    d.setData(artefact);
    rs.add(d);


    return rs;
  }

  

  //`````````````````````
  // tests
  //`````````````````````

  /**
   * 
   * test the creation of the graph
   * 
   */

  public void test_search() {

    getShell().setLayout(new FillLayout());
    ResultSetView rsView = ResultSetView.build(getShell());
    Project project = new VCRProject();
    rsView.setDepot(project.getDepot());
    rsView.setHistory(project.getHistory());
    
    
    assert_gui("Testing Label Provider","Were they okay?");    
    
  }




}
