package ca.aura.ui.swt;

import java.io.File;
import java.util.Iterator;

import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.FillLayout;

import ca.aabeka.util.Debug;
import ca.aabeka.xml.XmlStream;
import ca.aura.artefacts.Artefact;
import ca.aura.artefacts.sorting.Data;
import ca.aura.artefacts.sorting.Folder;
import ca.aura.project.Depot;
import ca.aura.project.Structure;
import ca.aura.xml.DepotXmlConverter;


import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * 
 * @author aforward
 *
 */
public class ShellViewTestUI extends AbstractTestUI {

  //```````````````````
  // all tests
  //```````````````````

  /**
   * 
   * the main runner
   * 
   */

  public static void main() {
    junit.textui.TestRunner.run(suite());
  }

  /**
   * 
   * the test suite to group tests together
   * 
   */

  public static Test suite() {
    return new TestSuite(ShellViewTestUI.class);
  }

  

  //`````````````````````
  // tests
  //`````````````````````

  /**
   * 
   * test the creation of the graph
   * 
   */
  
  public void test_constructor() {

    getShell().setLayout(new FillLayout());
    ShellView sview = ShellView.build(getShell());
    
    Shell shell = new Shell(getShell(), SWT.DIALOG_TRIM);
    ParametersUI.build(shell);
    
    shell.setLayout(new FillLayout());
    shell.pack();
    shell.open();

    shell = new Shell(getShell(), SWT.DIALOG_TRIM);
    MaintenanceTask.build(shell);
    shell.setLayout(new FillLayout());
    shell.pack();
    shell.open();
    
    //sview.setDepot(DepotViewTestUI.buildDepot());
    sview.setResultSet(ResultSetViewTestUI.buildResultSet());
    sview.setGraph(WhiteBoardViewTestUI.getObject(),WhiteBoardViewTestUI.buildGraph());
    
    File f = new File("C:\\users\\aforward\\projects\\aura\\src\\testdata\\depot.aura");
    assertTrue("file: " + f + " should exist",f.exists());
    XmlStream stream = new XmlStream(new DepotXmlConverter(),f);
    
    assertTrue("should be able to read the xml",stream.read());
    assertTrue("should be instance of depot: " + stream.getObject().getClass(),stream.getObject() instanceof Depot);
    
    
    Depot depot = (Depot)stream.getObject();
    
    
    Structure config = new Structure();
    Folder folder = new Folder("all");
    
    Data d;
    
    Iterator iter = depot.getArtefacts();
    while (iter.hasNext()) {
      d = new Data("-");
      d.setData((Artefact)iter.next());
      folder.add(d);
      
      Debug.defaultPrintln(this,"just added: " + d.getData());
    }
    
    sview.setDepot(config);
    
    
    assert_gui("Testing Label Provider","Were they okay?");
    
  }  

}
