package ca.aura.ui.swt;

import org.eclipse.swt.layout.FillLayout;

import ca.aura.artefacts.AbstractArtefact;
import ca.aura.artefacts.AbstractAura;
import ca.aura.artefacts.Doc;
import ca.aura.artefacts.SourceCode;
import ca.aura.artefacts.Webpage;
import ca.aura.artefacts.sorting.Data;
import ca.aura.artefacts.sorting.Folder;
import ca.aura.project.Project;
import ca.aura.project.Structure;
import ca.aura.project.VCRProject;

import junit.framework.Test;
import junit.framework.TestSuite;

/**
 * 
 * @author aforward
 *
 */
public class StructureViewTestUI extends AbstractTestUI {

  //```````````````````
  // all tests
  //```````````````````

  /**
   * 
   * the main runner
   * 
   */

  public static void main() {
    junit.textui.TestRunner.run(suite());
  }

  /**
   * 
   * the test suite to group tests together
   * 
   */

  public static Test suite() {
    return new TestSuite(StructureViewTestUI.class);
  }


  public static Structure buildStructure() {
    Structure structure = new Structure("name");
    Folder f;
    Data d;
    AbstractArtefact artefact;
        
    f = new Folder("f1");
    d = new Data("d1");
    
    artefact = new SourceCode("1");
    artefact.addAura(new AbstractAura("1.1"));
    artefact.addAura(new AbstractAura("1.2"));
    artefact.addAura(new AbstractAura("1.3"));
    
    d.setData(artefact);
    f.add(d);
    structure.add(f);

    f = new Folder("f2");
    d = new Data("d2");
    
    artefact = new Webpage("2");
    artefact.addAura(new AbstractAura("2.1"));
    artefact.addAura(new AbstractAura("2.2"));

    d.setData(artefact);
    f.add(d);    
    structure.add(f);

    f = new Folder("f2");
    d = new Data("d2");
    
    artefact = new Doc("3");
    artefact.addAura(new AbstractAura("3.1"));
    artefact.addAura(new AbstractAura("3.2"));
    artefact.addAura(new AbstractAura("3.3"));
    artefact.addAura(new AbstractAura("3.4"));

    d.setData(artefact);
    f.add(d);      
    structure.add(f);
    
    return structure;
  }
  

  //`````````````````````
  // tests
  //`````````````````````

  /**
   * 
   * test the creation of the graph
   * 
   */
  
  public void test_constructor() {

    getShell().setLayout(new FillLayout());
    StructureView dview = StructureView.build(getShell());

    Project project = new VCRProject();
    dview.setStructure(project.getStructure());
    assert_gui("Testing Label Provider","Were they okay?");
    
    
    
  }  


}
