package ca.aura.xml;

import junit.framework.Test;
import junit.framework.TestSuite;

import ca.aabeka.xml.AbstractXmlConverterTest;
import ca.aabeka.xml.ObjectXmlConverter;
import ca.aura.artefacts.AbstractArtefact;
import ca.aura.artefacts.Description;
import ca.aura.artefacts.Location;

/**
 * 
 * @author aforward
 *
 */
public class ArtefactXmlConverterTest extends AbstractXmlConverterTest {

  //```````````````````
  // all tests
  //```````````````````

  /**
   * 
   * the main runner
   * 
   */

  public static void main() {
    junit.textui.TestRunner.run(suite());
  }

  /**
   * 
   * the test suite to group tests together
   * 
   */

  public static Test suite() {
    return new TestSuite(ArtefactXmlConverterTest.class);
  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#getConverter()
   */
  public ObjectXmlConverter getConverter() {
    return new ArtefactXmlConverter();
  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#test_load()
   */
  public void test_load() {

    String aura = "<aura name='123'><description category='456'>my first</description></aura>";
    String location = "<location>here</location>";
    String xml = "<artefact id='x'>" + aura + location + "</artefact>";
    
    AbstractArtefact expected = new AbstractArtefact("x");
    expected.setName("123");
    expected.setDescription(new Description("456","my first"));
    expected.setLocation(new Location("here"));
    
    assert_load(xml,expected);

  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#test_build()
   */
  public void test_build() {
    String aura = "<aura name='123'><description category='456'>my first</description></aura>";
    String location = "<location>here</location>";
    String expected = "<artefact id='x'>" + aura + location + "</artefact>";
    
    AbstractArtefact obj = new AbstractArtefact("x");
    obj.setName("123");
    obj.setDescription(new Description("456","my first"));
    obj.setLocation(new Location("here"));
    
    assert_build(obj,expected);  
  
  }

}
