package ca.aura.xml;

import junit.framework.Test;
import junit.framework.TestSuite;

import ca.aabeka.xml.AbstractXmlConverterTest;
import ca.aabeka.xml.ObjectXmlConverter;
import ca.aura.artefacts.AbstractAura;
import ca.aura.artefacts.Description;

/**
 * 
 * @author aforward
 *
 */
public class AuraXmlConverterTest extends AbstractXmlConverterTest {

  //```````````````````
  // all tests
  //```````````````````

  /**
   * 
   * the main runner
   * 
   */

  public static void main() {
    junit.textui.TestRunner.run(suite());
  }

  /**
   * 
   * the test suite to group tests together
   * 
   */

  public static Test suite() {
    return new TestSuite(AuraXmlConverterTest.class);
  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#getConverter()
   */
  public ObjectXmlConverter getConverter() {
    return new AuraXmlConverter();
  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#test_load()
   */
  public void test_load() {
    String xml = "<aura name='123'><description category='456'>my first</description></aura>";
    AbstractAura expected = new AbstractAura("123");
    expected.setDescription(new Description("456","my first"));
    assert_load(xml,expected);
  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#test_build()
   */
  public void test_build() {
    String expected = "<aura name='123'><description category='456'>my first</description></aura>";
    AbstractAura obj = new AbstractAura("123");
    obj.setDescription(new Description("456","my first"));
    assert_build(obj,expected);
  }

}
