package ca.aura.xml;

import junit.framework.Test;
import junit.framework.TestSuite;

import ca.aabeka.xml.AbstractXmlConverterTest;
import ca.aabeka.xml.ObjectXmlConverter;
import ca.aura.artefacts.Location;

/**
 * 
 * @author aforward
 *
 */
public class LocationXmlConverterTest extends AbstractXmlConverterTest {

  //```````````````````
  // all tests
  //```````````````````

  /**
   * 
   * the main runner
   * 
   */

  public static void main() {
    junit.textui.TestRunner.run(suite());
  }

  /**
   * 
   * the test suite to group tests together
   * 
   */

  public static Test suite() {
    return new TestSuite(LocationXmlConverterTest.class);
  }


  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#getConverter()
   */
  public ObjectXmlConverter getConverter() {
    return new LocationXmlConverter();
  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#test_load()
   */
  public void test_load() {
    String xml = "<location>blah</location>";
    Object expected = new Location("blah");    
    assert_load(xml, expected);
  }

  /**
   * @see ca.aabeka.xml.AbstractXmlConverterTest#test_build()
   */
  public void test_build() {
    Object obj = new Location("blah");
    String expected = "<location>blah</location>";
    assert_build(obj, expected);
  }

}
